2021-08-16  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.52.5

2021-08-16  wxx  <769218589@qq.com>

	vala: Disallow resize() for constant arrays
	See https://gitlab.gnome.org/GNOME/vala/issues/944

2021-08-16  Ole André Vadla Ravnås  <oleavr@gmail.com>

	gobject-2.0: Fix the Closure.invoke() signature
	The return value must be initialized by the caller, as is clear from
	GLib's internal callers, and e.g. dummy_closure_marshal() on the callee
	side. So it appears the GLib type annotation is incorrect, as it
	specifies `out` but should be `inout`.

2021-08-16  Rico Tzschichholz  <ricotz@ubuntu.com>

	gstreamer: Update from 1.19.0+ git master

	gtk4: Update to 4.3.2+04f3c805

	girwriter: Write missing c:type attribute of compact class record
	Thanks to Niels De Graef

2021-08-09  Rico Tzschichholz  <ricotz@ubuntu.com>

	Partly revert "gstreamer: Update from 1.19.0+ git master"
	This partly reverts commit e1f0316ba4fba6e47f91fbe447ab8e6db038a54b.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1210

	Slightly improve source_reference for get_dup_func_expression()

	girparser: Add support for "final" class attribute

	girwriter: Fix position of "result" parameter for struct constructor
	Thanks to Princeton Ferro

2021-08-09  Princeton Ferro  <princetonferro@gmail.com>

	girwriter: Add explicit writable attribute to all field elements
	This addresses issues with bindings to Vala structs.

2021-07-19  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Rely on DataType.to_qualified_string() implementation for error-types
	DataType.type_symbol is properly initialized and can be used.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1206

2021-07-19  satmandu  <satadru@umich.edu>

	docs: Update bootstrap instructions in README.md

2021-07-19  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Fix params-array in constructor for struct
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1202

2021-07-19  Princeton Ferro  <princetonferro@gmail.com>

	glib-2.0: Add Uri.to_string/to_string_partial() (since 2.66)

2021-07-19  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Use detroy_value() for delete statement
	It is required to deal with special free functions here.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1201

	vapi: Update GIR-based bindings

	gtk4: Update to 4.3.1+6818eee8

	gstreamer: Update from 1.19.0+ git master

2021-07-19  Princeton Ferro  <princetonferro@gmail.com>

	glib-2.0: expected_type and return value of VariantDict.lookup_value() is nullable

2021-07-19  Dr. Michael Lauer  <mickey@vanille-media.de>

	linux: Fix i2c-dev constants
	This commit enables basic i2c operations (open/read/write/close) from userland.
	Further i2c / smbus transfer modes are on the way.

2021-07-19  Rico Tzschichholz  <ricotz@ubuntu.com>

	linux: Fix some bindings errors

2021-07-19  Dr. Michael Lauer  <mickey@vanille-media.de>

	linux: Substitute linux/if.h with net/if.h
	There is an age-old conflict between linux/if.h (the kernel header) and
	net/if.h (the userland header) that leads to compile errors due to
	redeclaration of certain network-related structures, see e.g. the following links:

	- https://bugs.launchpad.net/ubuntu/+source/eglibc/+bug/673073
	- https://lists.debian.org/debian-kernel/2017/06/msg00003.html
	- https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=824442

	FWIW, it still seems to be a very current problem which I just stumbled over _again_.
	By now all the relevant structures should have counterparts in net/if.h, so let's try
	to just not include the kernel header, but use the userland header instead.

2021-07-19  Rico Tzschichholz  <ricotz@ubuntu.com>

	Recognize multiple valid CCode.gir_namespace/_version attributes in VAPI files
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1189

	testrunner: Add support for girwriter tests

	girwriter: Respect GIR.name for constants, errordomains and delegates
	See https://gitlab.gnome.org/GNOME/vala/issues/1196

	tests/girwriter: Add missing [Flags] annotation

	codegen: Fix variadic constructors for compact classes and structs
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1195

	codegen: Implementing GLib.Source.prepare/check is optional since 2.36

	codegen: Allow null to initialize non-null struct inside initializer list
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/594

2021-06-04  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.52.4

2021-05-27  Rico Tzschichholz  <ricotz@ubuntu.com>

	glib-2.0: Add missing has_typedef attributes on SourceFuncs delegates

	gtk+-3.0: Update to 3.24.29+f9fe28ce

	gtk4: Update to 4.3.0+24f0ae1d

	pango: Mark language parameter of AttrIterator.get_font() as out

	gstreamer: Update from 1.19.0+ git master

	vala: Parameter following params-array parameter is not allowed
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1183

	codegen/vala: Improve check for GLib.Source derived classes

2021-05-19  Rico Tzschichholz  <ricotz@ubuntu.com>

	vapi: Update GIR-based bindings

	tests: Add "no-reply" DBus test to increase coverage

	codegen: Mark entry point method implementation "_vala_main" as static
	Thanks to Al Thomas

2021-05-19  Alistair Thomas  <astavale@yahoo.co.uk>

	doc: Update man page to include more information on profiles

2021-05-18  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't add errornous cast for unknown type_symbol
	This causes invalid C code for reference transfer of GenericType.

	Regression of 7ae2f115a702439bd94bf09867b38019f39d010f

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1180

	codegen: Replace wrongly hard coded usage of G_OBJECT_GET_CLASS
	This is used by plain GTypeInstance classes as well.

2021-05-07  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Refactor "fields" test to increase coverage

	tests: Add "ThreadPool" test to increase coverage

	codegen: GArray, GByteArray and GPtrArray are reference counted

2021-05-02  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add "properties in structs" test to increase coverage

	tests: Extend "array field intializer" test to increase coverage

	tests: Add "generic array" test to increase coverage

	tests: Add "delete" test to increase coverage

2021-05-01  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.52.3

2021-04-27  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't use G_GNUC_INTERNAL on implicit type specific fields
	The actual field was never handled that way, so don't apply it at all
	when --hide-internal is passed.

	Introduced by 970f58989a2863faca11e30fdbcf4da1273a6acd which claimed to
	apply it to methods only.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1178

2021-04-26  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Report a warning for unhandled errors in destructors
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1176

	codegen: Add missing "_return" label and "_inner_error*_" declaration in dtors

	vala: length-type of arrays must not be nullable (2)

2021-04-20  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add more "DBus" tests to increase coverage

	tests: Add "generics reference transfer" test to increase coverage

	tests: Extend "finally block execution" test to increase coverage
	In addition to 9f21d0b182edad861f93a91674787b8b3b4fc2c5

	See https://bugzilla.gnome.org/show_bug.cgi?id=579101

	codegen: Use if-clause for is_in_destructor() condition to be more clear

	codegen: Fix access to captured generics in async method of interfaces (2)
	See https://gitlab.gnome.org/GNOME/vala/issues/537

	codegen: Apply gconstpointer to gpointer cast to GenericType only

	vala: length-type of arrays must not be nullable

	parser: Include INTERR token in source_reference of parsed types

	parser: Allow empty member-initializer and accept trailing comma

	parser: Minor semantic checks to improve error messages

2021-04-12  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.52.2

2021-04-12  Nahuel Gomez Castro  <nahual_gomca@outlook.com.ar>

	glib-2.0: Add simple_generics attribute to GenericArray.find_custom()

2021-04-12  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't free unowned heap allocated struct
	Regression of 63551acaf0d83fac8b50904c2759c1098fbfaa71

2021-04-11  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Extend "GArray" tests to increase coverage

	codegen: Don't free temp-var for element-access to array with boxed structs (2)
	See https://gitlab.gnome.org/GNOME/vala/issues/1174

	codegen: Don't free temp-var for element-access to array with boxed structs
	Check the symbol_reference of inner element-access as needed.

	Regression of 63551acaf0d83fac8b50904c2759c1098fbfaa71

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1174

2021-04-08  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.52.1

	tests: Extend "this chainup in compact class" test

2021-04-07  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't call *_instance_init() in compact class chainup
	Found by -fsanitize=address

2021-04-06  Rico Tzschichholz  <ricotz@ubuntu.com>

	libusb: Fix some bindings errors

	libusb-1.0: Fix some bindings errors

	x11: Fix some bindings errors

	zlib: Fix some bindings errors

	pixman-1: Fix some bindings errors

	codegen: Don't override valid target/destroy of previous lambda argument
	This does not enable proper support for delegates sharing a data argument,
	but allows this special case.

	See https://gitlab.gnome.org/GNOME/vala/issues/59

	codegen: Always use CCodeConstant for NULL

	codegen: Fix default value of get_ccode_destroy_notify_pos() and make use of it

2021-04-05  Rico Tzschichholz  <ricotz@ubuntu.com>

	javascriptcoregtk-4.0,webkit2gtk-web-extension-4.0: Fix some binding errors

	girwriter: Don't use instance-parameter inside callback (2)
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1167

2021-04-01  Rico Tzschichholz  <ricotz@ubuntu.com>

	girwriter: Don't use instance-parameter inside callback
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1167

	tests/girwriter: Add tests for implicit parameters in virtual-method/callback

	codegen: Improve handling of ellipsis parameter in get_ccode_name()

2021-03-31  Rico Tzschichholz  <ricotz@ubuntu.com>

	girwriter: namespace expects "c:symbol-prefixes" attribute
	In addition to ef9c592dac6ee3a6db39e924de423e23e5f4a4ef

	See https://gitlab.gnome.org/GNOME/vala/issues/1038

	gio-2.0: Fix TlsPassword.get_value() binding

	gtk+-3.0: Fix ModuleInitFunc binding

	rest-0.7: Fix OAuthProxyAuthCallback binding

2021-03-21  Rico Tzschichholz  <ricotz@ubuntu.com>

	parser: Stricter mode for chained member initializer with --keep-going
	Regression of 86bc23f2d7295ae3b2f5f79449d2c5a4a7a93a58

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1158

2021-03-20  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Mark tranformed static member-access as qualified
	Regression of 1084348f3a6d1113dfc09b3bb5ca6b94a0d812e9

	See https://gitlab.gnome.org/GNOME/vala/issues/270

	libvaladoc/girimporter: parse_constant() use "c:identifier" attribute first

	libvaladoc/girimporter: Don't guess length of xml header, iterate forward to <repository>
	If e.g. the xml header is missing, it resulted in errors like:

	    error: expected start element of `repository'
	    error: unsupported GIR version (null) (supported: 1.2)

2021-03-19  Rico Tzschichholz  <ricotz@ubuntu.com>

	girparser: Don't guess length of xml header, iterate forward to <repository>
	If e.g. the xml header is missing, it resulted in errors like:

	    error: expected start element of `repository'
	    error: unsupported GIR version (null) (supported: 1.2)

2021-03-17  Akarin  <769218589@qq.com>

	gsl: Add BLAS module
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1149

2021-03-17  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.52.0

2021-03-16  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Check for unused attributes unconditionally

	vapi: Fix a couple of attribute typos

	gio-2.0: Add some missing NoWrapper and CCode.has_typedef attributes

	girparser: Add support for NoWrapper metadata for methods

	codegen: Include "glib.h" for deprecated symbols (GOBJECT)
	It is required for G_GNUC_DEPRECATED in declarations of
	enums, delegates, methods, property accessors and structs.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1155

2021-03-15  Rico Tzschichholz  <ricotz@ubuntu.com>

	gtk4-unix-print: Switch to gir
	Use a temporary symlink to Gtk-4.0.gir which includes the required
	symbol defintions.

	girparser: Handle empty "<type/>" element and report an error

	gstreamer: Update from 1.19.0+ git master

	gtk4: Update to 4.1.2

	webkit2gtk-4.0: Update to 2.31.91

2021-03-14  Rico Tzschichholz  <ricotz@ubuntu.com>

	build: Add --enable-test-asan configure option
	List XFAIL tests if address sanatizer is enabled

	linux: Provide Input.Event.input_event_sec/input_event_usec fields
	Mark Input.Event.time as deprecated

	See https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit?id=152194fe9c3f

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1152

	vala: Improve error for incompatible expressions in conditional expression

	gsl: Fix more binding errors

	girparser: Allow overriding of "Compact" attribute for classes

	gtk4: Add Gtk.INVALID_LIST_POSITION
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1151

2021-03-12  Rico Tzschichholz  <ricotz@ubuntu.com>

	gsl: Fix some binding errors

	gnutls: Fix some binding errors

2021-03-10  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.51.91

	vapi: Update GIR-based bindings

	vala: Replace all type parameter occurances in parameters for signal delegate
	Improves 36999b5ffd63cc56a8648791b02bf07e7da88077

	codegen: Drop inner casts before converting between generics and integers
	Found by -Wpointer-to-int-cast

2021-03-09  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't add generics arguments/parameters to async finish method

	codegen: Don't ever create null-aware free macro for GenericType

	tests: Add "string concat" test for POSIX to increase coverage

	codegen: Fix access to captured generics in async method of interfaces
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/537

	codegen: Use the one available source_reference for internal error
	This will at least provide some pointer to where things are going wrong.

	In addition to 837d593e00d1a3ca8a6f2d13fb1514bed7672965

	See https://gitlab.gnome.org/GNOME/vala/issues/436

	codegen: Free intermediate temp-variables of postcondition expression
	and not clearing "temp_ref_values" caused invalid references later.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/80

2021-03-07  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Report error for missing type-arguments of HashTable (de)serialization
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1147

	vala: Check (optional) type-arguments of array creation expression

	vala: Check array type of declarations for errornous type-arguments

	vala: Move type-argument/-parameter count check to DataType.check_type_arguments()

	gio-2.0: Add some missing type-arguments

	glib-2.0: Add some missing type-arguments

	vala: Add missing null-check in DataType.get_type_signature()
	If an instance struct field can not be resolved to a valid
	type-signature then bail.

	This fixes criticals like:

	    g_string_insert_len: assertion 'len == 0 || val != NULL' failed

2021-03-06  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.51.90

	gdbus: Don't leak memory of deserialized arguments on error in wrapper method
	Found by -fsanitize=address

	gtk4: Update to 4.1.1+f8f90d85

	vala: Fix ownership inheritance of "unowned var" in foreach statement

2021-03-05  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add more "gir" tests to increase coverage

	testrunner: Include Gio-2.0/gio-2.0 for GIR tests too

	Use pre-resolved symbol/type of SemanticAnalyzer if possible

	codegen: More use of get_ccode_type_name()

	codegen: Inherit GType from base struct of SimpleType structs
	GValue functions and marshaller type are inherited from base structs
	already.

	This avoids invalid C code which referenced an unavailable GType.

2021-03-04  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add more "gir" tests to increase coverage

	Regenerate GIR-based bindings to pick up missing class methods

	girparser: Evaluate "glib:type-struct" twice to pick up reparented structs

	codegen: "_first_array" parameter for params-array is variadic too
	Not following this resulted in mismatching signature assumptions between
	caller and callee if the callable throws an error.

2021-03-03  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Extend "pre-post increment" test to increase coverage

	tests: Add "target-glib=auto" tests to increase coverage

	tests: Add some tests to increase coverage

	vala: Fix build with valac < 0.44

	vala: Report warning if --target-glib=auto was not evaluated successfully
	and don't try to process the valid "auto" string any further.

	codegen: More use of get_ccode_type_name()

	Regenerate GIR-based bindings to pick up missing type_cname attributes

	girparser: Reuse populated Node.gtype_struct_for instead of resolving again
	This fixes the discovery of non-default type_cname for re-parented symbols.

2021-02-27  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.51.3

	vapi: Update GIR-based bindings

	glib-2.0: Add new symbols from 2.68

	webkit2gtk-4.0: Update to 2.31.90

	tests: Add some "unary expressions" tests to increase coverage

	vala: Report error for invalid inner operand of unary expressions
	This fixes criticals like:

	    vala_unary_expression_is_integer_type: assertion 'type != NULL' failed

	vala: Set proper source_reference for implicit "this" and "result" variables

	tests: Add more "unsupported creation method" tests to increase coverage

2021-02-26  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Include "stdlib.h" for Enum.to_string() (POSIX)
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1143

	codegen: Include "string.h" for strcmp() (POSIX)

	vala: Improve context check whether property is writeable on assignments

2021-02-24  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't wrongly emit declaration for default-handler of signals
	This is done in GTypeModule.generate_interface_declaration()

2021-02-22  Rico Tzschichholz  <ricotz@ubuntu.com>

	vapi: Update GIR-based bindings

2021-02-21  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add more "girparser" tests to increase coverage

	vala: Don't allow "in" operation with different enum types
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1139

	vala: Infer needle type for "in" expression on enum
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1138

2021-02-20  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests/girwriter: Increase coverage

	girwriter: Output default handler of signals

2021-02-19  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: CCodeBaseModule.get_type_id_expression () won't return null

	vala: Generics value holding struct pointer requires casting on access
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/347

	codegen: Don't use volatile modifier in glib API when targetting >= 2.68
	See https://gitlab.gnome.org/GNOME/glib/merge_requests/1719

2021-02-18  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.51.2

2021-02-16  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Properly parse and handle chained initialization of members
	Make MemberInitializer an Expression, so it is possible to descibe
	nested/chained member initializers in the AST.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1137

	vala: Move SemanticAnalyzer.vist_member_initializer() to MemberInitializer

	vala: Simplify Expression.parent_statement

	codegen: Report error for unsupported symbol_reference of MemberInitializer

	vala: Capturing va_list parameters/variables is not allowed
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1136

	codewriter: Don't write trailing ";" after body of WithStatement

	codewriter: Output valid vala syntax for LoopStatement

2021-02-15  Rico Tzschichholz  <ricotz@ubuntu.com>

	vapi: Update GIR-based bindings

	gstreamer: Update from 1.19.0+ git master

2021-02-13  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Include type-checks in preconditions of methods for type narrowing
	See https://gitlab.gnome.org/GNOME/vala/issues/894

	vala: Check type-arguments in base-types/prerequisites of class/interface
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/404

2021-02-12  Rico Tzschichholz  <ricotz@ubuntu.com>

	Release 0.51.1

2021-02-08  Rico Tzschichholz  <ricotz@ubuntu.com>

	sdl2: Fix a couple of binding errors and attribute issues

	codegen: Include <string.h> for memcpy usage in _vala_memdup2()

2021-02-07  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Strip all nested occurances of CCodeCastExpression
	Triggered by 63551acaf0d83fac8b50904c2759c1098fbfaa71

	See https://gitlab.gnome.org/GNOME/vala/issues/1134

	build: Ease source for AC_LANG_SOURCE of CGRAPH check

	libvaladoc: Add wrapper for "agedge" of graphviz

	codegen: Correctly retrieve symbol_reference of nested cast expressions
	Regression of 63551acaf0d83fac8b50904c2759c1098fbfaa71

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1134

2021-02-06  Rico Tzschichholz  <ricotz@ubuntu.com>

	vapi: Add libunwind-generic binding

	gio-2.0: Update to 2.67.3

	gtk4: Update to 4.1.0+2712f536

	gstreamer: Update from 1.19.0+ git master

2021-02-05  Rico Tzschichholz  <ricotz@ubuntu.com>

	gee: Replace Memory.dup() with GLib.malloc() and Memory.copy()

	gstreamer-1.0: Set CCode.type_id of MiniObject to G_TYPE_BOXED
	Fixed https://gitlab.gnome.org/GNOME/vala/issues/1133

2021-02-04  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Replace "g_memdup" with "_vala_memdup2" for target glib < 2.68
	"_vala_memdup2" is a copy of "g_memdup2" available in glib >= 2.68

	glib-2.0: Add new symbols from 2.68

	codegen: Use g_memdup2 if target glib >= 2.68 is set
	See https://gitlab.gnome.org/GNOME/glib/issues/2319

	testrunner: Add "-Werror=return-stack-address" flag

	vala: Add Block.unreachable_exit and have it set accordingly by FlowAnalyzer
	Use this control flow information in codegen rather than doing an
	educated guess based on occurring ReturnStatement nodes.

	See https://gitlab.gnome.org/GNOME/vala/issues/838

	tests: Don't leak array if length is -1
	Found by -fsanitize=address

	codegen: Chain up to base struct destroy function
	Found by -fsanitize=address

2021-02-03  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't leak memory moving heap-allocated struct to stack
	Found by -fsanitize=address

	codegen: Use temp_ref_values list instead of patching the AST
	Simplyfies 5328619a8141aa11341d479428ebfdcec0ff9756

	codegen: Don't leak GLib.Value when implicitly unboxing it
	Found by -fsanitize=address

	vala: Don't allow GLib.Value casting to nullable struct/simple types

	vala: GLib.Value unboxing returns unowned value

	codegen: Use g_boxed_free in free-wrapper for heap-allocated GLib.Value
	dup-wrapper is specifically using g_boxed_copy already

2021-02-02  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Don't leak array memory after it was implicitly copied
	Found by -fsanitize=address

2021-02-01  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Improve handling of recursive DelegateType
	Move dedicated test case into a separate file

	codegen: Make sure types of implicit delegate parameters are declared

	codegen: Use CCodeDeclaratorSuffix to emit array length of constants

	ccode: Minor API cleaning and additions

	vala: Rename Loop to LoopStatement and introduce a common base class

	codegen: Also check array type of variable argument for ref parameters

	codegen: Add get_ccode_no_wrapper() and use it

2021-01-31  Rico Tzschichholz  <ricotz@ubuntu.com>

	girparser: Set CCode.type_cname for classes if it doesn't match our default

	tests/girwriter: Add tests for async methods attributed with NoWrapper

	codegen: Don't emit invoker for async methods attributed with NoWrapper

	libxml-2.0: Fix a few binding errors

	fuse: Fix a few binding errors

2021-01-30  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Always use G_TYPE_INSTANCE_GET_CLASS/INTERFACE for external symbols
	and get_ccode_type_get_function() for SourceFileType.SOURCE symbols.

	codegen: Handle NoWrapper attribute of async methods on caller side

	codegen: Allow CCode.type_cname for classes and use get_ccode_type_name()

	girparser: Apply "type_get_function" metadata for classes and inferfaces

	codegen: Add CCode.type_get_function and get_ccode_type_get_function()
	Allow to overide the macro name, and join get_ccode_class_get_function ()
	and get_ccode_interface_get_function().

	gtk+-2.0,javascriptcoregtk-4.0: Wrong usage of CCode.type_cname attribute

	girwriter: Don't emit invoker for methods attributed with NoWrapper

	codegen: Don't emit invoker for methods attributed with NoWrapper

	codegen: Handle NoWrapper attribute of interface methods on caller side

	vala: NoWrapper methods must be declared abstract or virtual

	gio-2.0: Pick up missing invoker for some AppInfo/File.*() methods

	gdk-pixbuf-2.0: Fix Pixbuf.save_to_streamv_async()

	gobject-2.0: Fix a few binding errors

	gdk-3.0,gdk-x11-3.0,gtk+-3.0,gtk4: Fix a few binding errors

2021-01-28  Rico Tzschichholz  <ricotz@ubuntu.com>

	Add further support for params arrays in constructors
	In addition to 98ab3da89640b8b8a6c67044b4df1194672774bb

	See https://gitlab.gnome.org/GNOME/vala/issues/128

2021-01-27  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Improve support of SimpleType struct constructors
	Additionally stop generating broken and superfluous dup/free functions,
	and don't create not used GType declarations.

	vala: Don't allow disposable SimpleType structs

	gstreamer-1.0: Fix a few binding errors

	posix: Fix a few binding errors

	libgvc: Fix a few binding errors

	sqlite3: Fix a few binding errors

	bzlib: Fix a few binding errors

	alsa: Fix a few binding errors

	curses: Fix a few binding errors

2021-01-26  Rico Tzschichholz  <ricotz@ubuntu.com>

	girparser: Apply "destroy_notify_cname" metadata for fields

	vala: Add CallableExpression interface for MethodCall/ObjectCreationExpression

	goocanvas-2.0: Fix some field types

	pango: Fix a few binding errors

	gobject-2.0: Fix a few binding errors

	gio-2.0,gtk+-3.0,gtk4: Drop explicit c-type attributes of va_list parameters

	gio-2.0: Fix binding of PollableOutputStream.write*_nonblocking()

	cairo: Fix some ctor binding errors

2021-01-25  Rico Tzschichholz  <ricotz@ubuntu.com>

	cairo: Fix a few binding errors

	gtk+-3.0,gtk4: Fix some delegate return values and parameters

	girparser: Apply "delegate_target" metadata for methods and parameters

	vala: Don't prepend "unowned" in VarType and leave that to the CodeWriter

	codewriter: Append new-line for nested block statements

2021-01-23  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Apply stricter condition for lambda to delegate assignment
	This moves an internal codegen error to the semantic-analyzer.

	codegen: Clean up expression casts in CCodeAssignmentModule.visit_assignment()

2021-01-22  Ole André Vadla Ravnås  <oleavr@gmail.com>

	vala: Avoid critical when trying to use symbol_reference of ElementAccess
	Regression of 6e7be51cb5455e9c5c721d4ba5121a6ab04673dd

2021-01-21  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add more "parser" tests to increase coverage

2021-01-20  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: Improve prototype-string of CallableType

	Update THANKS from git log

	valadoc: Replace png icons with elementary's svg version
	These match what was introduced by 8af8158c106eaafe12a628514f74e5788274d8d2

	The icons were written by Daniel Foré for valadoc.org. They were taken from
	https://github.com/Valadoc/valadoc-org

	vapi: Update GIR-based bindings

	gstreamer: Update from 1.19.0+ git master

	gtk4: Update to 4.0.2

2021-01-19  Rico Tzschichholz  <ricotz@ubuntu.com>

	girparser: Discover our very own array length fields

	vala: Make Class.is_compat/is_immutable/is_singleton read-only

	libvaladoc: Correctly retrieve value for Api.Class.is_compact

2021-01-19  Simon Werbeck  <simon.werbeck@gmail.com>

	Add support for 'opaque' compact classes
	This change intruduces a new attribute switch [Compact (opaque = true)]
	which allows to completely hide the implementation of a compact class.
	This is especially useful for libraries when maintaining a stable abi.

	An 'opaque' compact class exposes no struct definition in the generated
	c header, only a typedef is provided. As such, certain requirements
	apply for members of such classes:
	- Access to instance fields must be either private or internal.
	- No abstract/virtual methods or properties are allowed.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1129

2021-01-18  Rico Tzschichholz  <ricotz@ubuntu.com>

	girwriter: Write instance-parameter elements
	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1128

	tests: Extend "girparser" test and use vapigen to parse generated gir

	vala: Let method representing property accessor inherit GIR.visible attribute

	vala: Set this_parameter of method representing property accessor

2021-01-17  Rico Tzschichholz  <ricotz@ubuntu.com>

	tests: Add more invalid "GtkTemplate" tests to increase coverage

	vala: Don't allow assigning GtkChild fields/properties
	These are handled exclusively by GtkBuilder

	See https://gitlab.gnome.org/GNOME/vala/issues/1121

2021-01-16  Rico Tzschichholz  <ricotz@ubuntu.com>

	vala: GtkChild fields/properties must be declared as unowned
	The backing field won't be assigned to hold a dedicated reference.
	gtk_widget_class_bind_template_child_full will make it point to the
	instance owned by GtkBuilder.

	This avoids doing a rogue (but safe) call of _g_object_unref0 on already
	disposed child.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1121

2021-01-15  Rico Tzschichholz  <ricotz@ubuntu.com>

	libvaladoc/html: Don't sort struct fields to keep their original order
	This follows their special handling done in Codewriter.visit_struct().

	In addition to a336d75586acb534aff55ca86425eb8f3aa45de4

2021-01-15  Reuben Thomas  <rrt@sc3d.org>

	libvaladoc: Fix typos copyright year

2021-01-14  Reuben Thomas  <rrt@sc3d.org>

	glib-2.0: Improve type of OptionEntry.flags field

2021-01-14  Rico Tzschichholz  <ricotz@ubuntu.com>

	Regenerate GIR-based bindings

	gdk-pixbuf-2.0: Update to 2.42.3~

	girparser: Minor improvement to field getter detection
	Allow DataType.compatible() to be called without initialized SemanticAnalyzer

	Additionally report a warning if field collides with method

	girparser: Handle anonymous delegate not backed by virtual-method or signal

2021-01-12  Rico Tzschichholz  <ricotz@ubuntu.com>

	webkit2gtk-4.0: Update to 2.31.1

	vala: Improve detection of duplicate package source files

2021-01-11  Rico Tzschichholz  <ricotz@ubuntu.com>

	Sync NEWS from 0.50

2021-01-09  Rico Tzschichholz  <ricotz@ubuntu.com>

	gio-2.0: Update to 2.67.2+46097e9b

	gtk4: Update to 4.0.1

2021-01-06  Rico Tzschichholz  <ricotz@ubuntu.com>

	codegen: Fix assignment of casted struct value to property
	Usage of address-of operator requires lvalue access. Therefore use a
	temporary variable to be passed to property setter.

	Fixes https://gitlab.gnome.org/GNOME/vala/issues/1126

2021-01-04  Rico Tzschichholz  <ricotz@ubuntu.com>
